<?php

namespace App\Filament\Resources\Inspecteurs\Tables;

use App\Actions\DownloadTemplateAction;
use App\Actions\ExportExcelAction;
use App\Actions\ImportExcelAction;
use App\Imports\InspecteurImport;
use App\Exports\InspecteurExport;
use Filament\Actions\BulkActionGroup;
use Filament\Actions\DeleteBulkAction;
use Filament\Actions\EditAction;
use Filament\Tables\Columns\TextColumn;
use Filament\Tables\Table;

class InspecteursTable
{
    public static function configure(Table $table): Table
    {
        return $table
            ->columns([
                TextColumn::make('nomfr')
                    ->searchable(),
                TextColumn::make('nomar')
                    ->searchable(),
                TextColumn::make('matricule')
                    ->searchable(),
                TextColumn::make('nni')
                    ->searchable(),
                TextColumn::make('date_naissance')
                    ->date()
                    ->sortable(),
                TextColumn::make('lieu_naissance_ar')
                    ->searchable(),
                TextColumn::make('lieu_naissance_fr')
                    ->searchable(),
                TextColumn::make('date_affectation')
                    ->date()
                    ->sortable(),
                TextColumn::make('contact')
                    ->searchable(),
                TextColumn::make('date_mise_en_corps_IES')
                    ->date()
                    ->sortable(),
                TextColumn::make('bank')
                    ->searchable(),
                TextColumn::make('compte')
                    ->searchable(),
                TextColumn::make('email')
                    ->label('Email address')
                    ->searchable(),
                TextColumn::make('matrimonialite')
                    ->searchable(),
                TextColumn::make('date_recri_fp')
                    ->date()
                    ->sortable(),
                TextColumn::make('photo')
                    ->searchable(),
                TextColumn::make('discipline.id')
                    ->searchable(),
                TextColumn::make('pole.id')
                    ->searchable(),
                TextColumn::make('created_at')
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
                TextColumn::make('updated_at')
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
            ])
            ->filters([
                //
            ])
            ->recordActions([
                EditAction::make(),
            ])
            ->toolbarActions([
                ImportExcelAction::makeImport(InspecteurImport::class),
                ExportExcelAction::makeExport(InspecteurExport::class, 'inspecteurs_export.xlsx'),
                DownloadTemplateAction::makeTemplate('inspecteur', 'template_inspecteurs.xlsx'),
                BulkActionGroup::make([
                    DeleteBulkAction::make(),
                ]),
            ]);
    }
}
